package CalculiX;

class ELet extends Expression {

  // The variable that is being declared.
  final String x;
  // The value with which this variable is initialized.
  final Expression left;
  // The expression that must be evaluated next.
  final Expression right;

  ELet (String x, Expression left, Expression right)
  {
    this.x = x;
    this.left = left;
    this.right = right;
  }

  public Value eval (Environment env) throws EvalException
  {
    // Evaluate the left-hand expression in the environment env.
    // Extend the environment with a binding of x to this value.
    // Use the extended environment to evaluate the right-hand
    // expression.
    Value v1 = left.eval(env);
    return right.eval(env.extend(x, v1));
  }

}
