package CalculiX;

// A trivial implementation of the interface ExpressionFactory.

// Each method simply invokes the constructor of the appropriate
// sub-class of the abstract class Expression.

class MyExpressionFactory implements ExpressionFactory {

  public Expression buildConstant (double d)
  {
    return new EConstant (d);
  }

  public Expression buildConstant (boolean b)
  {
    return new EConstant (b);
  }

  public Expression buildDoubleOperation (Expression left, Operator op, Expression right)
  {
    return new EDoubleOperation (left, op, right);
  }

  public Expression buildBooleanOperation (Expression left, Connective op, Expression right)
  {
    return new EBooleanOperation (left, op, right);
  }

  public Expression buildBooleanNegation (Expression e)
  {
    return new EBooleanOperation (e, Connective.XOR, new EConstant (true));
  }

  public Expression buildDoubleComparison (Expression left, Comparator op, Expression right)
  {
    return new EDoubleComparison (left, op, right);
  }

  public Expression buildIf (Expression condition, Expression then_branch, Expression else_branch)
  {
    return new EIf (condition, then_branch, else_branch);
  }

  public Expression buildLet (String x, Expression left, Expression right)
  {
    return new ELet (x, left, right);
  }

  public Expression buildVarRead (String x)
  {
    return new EVarRead (x);
  }

  public Expression buildFunApp (String f, Expression e)
  {
    return new EFunApp (f, e);
  }

}
